// Battle Support lua
// Co-written by CobaltBW
local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
	BattleFuncSet = true
	
	local DirkSpecial = function(mo,doaction,pressedaction)
		local player = mo.player

		player.actiontext = "Frost Stun"
		player.actionrings = 16
-- 			player.disableringslinger = true
		player.actionsuper = true
		//Ability start
		if player.actionstate == 0 and doaction == 1 then
			player.actionstate = 1
			player.actiontime = 0
			CBW_Battle.PayRings(player)
			S_StartSound(mo,sfx_s3ka4)
		end

		//Prep attack
		if player.actionstate == 1 then
			player.actiontime = $+1
			
			local icegather = P_SpawnMobj(mo.x,mo.y,mo.z+mo.height/2,MT_ENERGYGATHER)
			if icegather and icegather.valid then
				icegather.target = mo
				icegather.state = S_ICEENERGY1
				icegather.fuse = 35
				icegather.extravalue1 = P_RandomRange(0,359)*ANG1
				icegather.extravalue2 = P_RandomRange(0,359)*ANG1
				icegather.scale = mo.scale*2
			end

			//Do attack
			if player.actiontime == 3*TICRATE/2 then 
				for n = 0, 23
					local stun = P_SPMAngle(mo,MT_ICESPRAY,mo.angle+n*ANG15,0)
					if stun and stun.valid then
						stun.translucency = FF_TRANS30
						stun.scale = mo.scale*2
						stun.momz = mo.scale*P_MobjFlip(mo)
						stun.fuse = TICRATE/2
					end
				end
				dirk_snowstormplayerfreezeiterator(mo, mo, 240*FRACUNIT, function(target, source)
					if (not target.player.dirk_frozen)
					and (not CBW_Battle.MyTeam(target.player, source.player))
						dirk_freezeplayer(target.player, source)
						P_AddPlayerScore(source.player, 25)
						if multiplayer and not (splitscreen) then 
							print(CBW_Battle.CustomHurtMessage(target.player,source,"frost stun","has frozen")) 
						end
					end
				end, false)
				player.actionstate = 2
				CBW_Battle.ApplyCooldown(player,7*TICRATE)
				player.actiontime = 0
				S_StartSound(mo,sfx_icevan)
			end
		end

		//Attack endlag
		if player.actionstate == 2 then
			player.actiontime = $+1
			if player.actiontime == 3*TICRATE/2 then
				player.actionstate = 0
			end
		end
	end
	
	CBW_Battle.SkinVars["dirk"] = {
 		weight = 95,
 		shields = 1,
		special = DirkSpecial,
 		guard_enabled = true,
 		guard_frame = 2,
 		func_guard_trigger = CBW_Battle.GuardFunc.Parry,
 		func_priority = CBW_Battle.Priority_FullCommon,
 		func_priority_ext = nil
	}
	
	print("Dirk BattleMod functions have been loaded.")
end)

addHook("PostThinkFrame", do
	for player in players.iterate
		if CBW_Battle and CBW_Battle.BattleGametype() then
			if player.dirk_frozen then
				player.actionallowed = false
				player.actionstate = 0
				player.actiontime = 0
				player.actioncooldown = 3*TICRATE
				player.mo.color = SKINCOLOR_ICY
				player.mo.colorized = true
			end
		end
	end
end)