//Whirl's main script by SMS Alfredo

addHook("ThinkFrame", do
	for player in players.iterate
		if player.mo and player.mo.valid and player.mo.skin == "whirl"
			if (player.mo.sprite2 == SPR2_SKID) then
				player.mo.frame = ((leveltime / 3) % 2)
			end
			if player.powers[pw_carry] == CR_DUSTDEVIL then
				player.mo.sprite2 = SPR2_WIND
			end
		end
	end
end)

//A very dangerous chasecam variable
local verydangerouschasecamvariable = true
hud.add(function(v, player, cam)
	verydangerouschasecamvariable = cam.chase
end)

//Spawn the ghost trail for ramming after hitting a spring
local function P_SpawnWhirlTrail(mo)
    local ghost = P_SpawnMobj(mo.x, mo.y, mo.z, MT_RAMGHOST)
	
	if not (ghost and ghost.valid) return end

    P_SetScale(ghost, mo.scale)
    ghost.destscale = mo.scale

    if (mo.eflags & MFE_VERTICALFLIP)
        ghost.eflags = $|MFE_VERTICALFLIP
        ghost.z = $ + mo.height - ghost.height
    end

	ghost.skin = mo.skin
    ghost.colorized = true
    ghost.angle = mo.angle
    if mo.player
        ghost.angle = mo.player.drawangle
    end
    ghost.sprite = mo.sprite
    ghost.sprite2 = mo.sprite2
    ghost.frame = mo.frame
    ghost.tics = -1
    ghost.frame = $ & ~FF_TRANSMASK
    ghost.frame = $|tr_trans30<<FF_TRANSSHIFT
	if mo.player.powers[pw_sneakers] then
		ghost.fuse = 3
	else
		ghost.fuse = 2
	end

    if (mo.flags2 & MF2_OBJECTFLIP)
        ghost.flags = $|MF2_OBJECTFLIP
    end

    if (mo.player and mo.player.followmobj)
        local ghost2 = P_SpawnGhostMobj(mo.player.followmobj)
        ghost2.tracer = ghost
        ghost.tracer = ghost2
        ghost2.flags2 = $|(mo.player.followmo.flags2 & MF2_LINKDRAW)
    end
    
    if mo.player.whirlramboost >= 94*FRACUNIT
		ghost.color = SKINCOLOR_RED
	elseif mo.player.whirlramboost >= 70*FRACUNIT
        ghost.color = SKINCOLOR_YELLOW
    else
        ghost.color = SKINCOLOR_BLUE
    end

    return ghost
end

//Spawns objects in a circle
//Stolen from Skip because I made it
local function whirlcircle(mobj, mobjtype, ns, vertical, vertangle)
	local i = 0	while i < 8
		local fa = (i*(ANGLE_180/4))
		local mo = P_SpawnMobj(mobj.x, mobj.y, mobj.z+(mobj.height/2), mobjtype)
		if mo and mo.valid
			if mobjtype == MT_DUST
				mo.state = S_SPINDUST1
			end
			if vertical
				mo.momz = FixedMul(sin(fa),ns)/2
				P_InstaThrust(mo, vertangle+ANGLE_90,
				FixedMul(cos(fa),ns)/2)
			else
				mo.momx = FixedMul(sin(fa),ns)/2
				mo.momy = FixedMul(cos(fa),ns)/2
			end
		end
		i = $+1
	end
end

//Custom version of P_NukeEnemies that will hit monitors, spikes, and never hit players in the air.
//Stolen from Yoshi because I can
local groundnuke = function(inflictor, source, radius)
	for mo in mobjs.iterate()
		if not (mo and mo.valid and mo.health)
			continue
		end
		
		if not (mo.flags & MF_SHOOTABLE) and not (mo.type == MT_EGGGUARD or mo.type == MT_MINUS
		or mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE)
			continue
		end

		if mo.type == MT_PLAYER and not G_RingSlingerGametype()
			continue // Don't hurt players in Co-Op
		end
		
		if not P_IsObjectOnGround(mo)
			continue
		end

		if abs(inflictor.x - mo.x) > radius or abs(inflictor.y - mo.y) > radius or abs(inflictor.z - mo.z) > radius
			continue // Workaround for possible integer overflow in the below -Red
		end

		if P_AproxDistance(P_AproxDistance(inflictor.x - mo.x, inflictor.y - mo.y), inflictor.z - mo.z) > radius
			continue
		end

		if mo.type == MT_MINUS and not (mo.flags & (MF_SPECIAL|MF_SHOOTABLE))
			mo.flags = (mo.flags & ~MF_NOCLIPTHING)|MF_SPECIAL|MF_SHOOTABLE
		end

		if mo.type == MT_EGGGUARD and mo.tracer //nuke Egg Guard's shield!
			P_KillMobj(mo.tracer, inflictor, source, DMG_NUKE)
		end
		
		if mo.type == MT_SPIKE or mo.type == MT_WALLSPIKE
			P_KillMobj(mo, inflictor, source, DMG_NUKE) //just murder spikes!
		end

		//Unlike the orignal script this always deals one damage, no matter what
		P_DamageMobj(mo, inflictor, source, 1, DMG_NUKE)
	end
end

//It's reset time
local function resetwhirl(player)
	if player.whirlram
		player.whirlram = false
		player.camerascale = FRACUNIT
		S_StopSoundByID(player.mo, sfx_s3kcfl)
		player.pflags = $&~PF_FORCESTRAFE
		player.normalspeed = skins[player.mo.skin].normalspeed
		player.charflags = $&~SF_RUNONWATER
	end
	if player.whirltornadojump
		player.normalspeed = skins[player.mo.skin].normalspeed
		S_StopSoundByID(player.mo, sfx_whrdrl)
	end
	player.whirlramspeed = player.speed
	player.whirltornadojump = 0
	player.whirlbonkangle = nil
end

addHook("PlayerSpawn", function(player)
	resetwhirl(player)
end)

//Whirlwind jump thing
addHook("AbilitySpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "whirl"
		if not (player.pflags&PF_THOKKED)
		and not (player.gotflag or player.gotcrystal)
		and not (player.dirk_frozen)
			player.pflags = $&~PF_JUMPED
			P_DoJump(player, false)
			player.pflags = $|PF_THOKKED|PF_CANCARRY
			player.mo.momz = $*2
			player.mo.state = S_PLAY_SPINDASH
			S_StartSoundAtVolume(player.mo, sfx_kc31, 96)
			player.whirltornadojump = 1
			player.normalspeed = skins[player.mo.skin].normalspeed/2
			P_InstaThrust(player.mo,0,0)
			local explode = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_EXPLODE)
			if explode and explode.valid explode.scale = $*2 end
		elseif player.whirltornadojump >= 1
		and player.mo.momz*P_MobjFlip(player.mo) <= 6*player.mo.scale
			player.mo.state = S_PLAY_SPINDASH
			P_SpawnGhostMobj(player.mo)
			S_StartSoundAtVolume(player.mo, sfx_whrdrl, 128)
			player.whirltornadojump = $+1
			P_SetObjectMomZ(player.mo, -36*FRACUNIT, false)
		end
		return true
	end
end)

//The slam can also be accessed via the spin button
addHook("JumpSpinSpecial", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "whirl"
		if player.whirltornadojump >= 1 and player.pflags&PF_THOKKED
		and player.mo.momz*P_MobjFlip(player.mo) <= 6*player.mo.scale
			player.mo.state = S_PLAY_SPINDASH
			P_SpawnGhostMobj(player.mo)
			S_StartSoundAtVolume(player.mo, sfx_whrdrl, 128)
			player.whirltornadojump = $+1
			P_SetObjectMomZ(player.mo, -36*FRACUNIT, false)
		end
		return true
	end
end)

//This is dumb
addHook("PreThinkFrame", do
for player in players.iterate
	if player.mo and player.mo.valid and player.mo.skin == "whirl"
	and player.whirlram and P_IsObjectOnGround(player.mo)
		if player.mo.flags2 & MF2_TWOD or twodlevel
			if player.drawangle > ANGLE_180
				player.cmd.sidemove = 1
			else
				player.cmd.sidemove = -1
			end
		else
			player.cmd.forwardmove = 1
		end
	end
end
end)

local RAMCHARGING_GHOST_TICS = 8 

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid and player.mo.skin == "whirl"
		if player.mo.state == S_PLAY_DASH or player.mo.state == S_PLAY_FLY
			if player.charability == CA_NONE
				player.charability = CA_GLIDEANDCLIMB
			end
		elseif player.charability == CA_GLIDEANDCLIMB
			player.charability = CA_NONE
		end
		
		//Disallows the rest of the code in certain circumstances
		if P_PlayerInPain(player)
		or (player.pflags & PF_SLIDING)
		or (player.pflags & PF_SHIELDABILITY)
		or player.powers[pw_carry] != CR_NONE
		or player.spectator
		or player.exiting
		or player.playerstate != PST_LIVE
		or not player.mo.health
		or player.panim == PA_PAIN
		or player.mo.state == S_PLAY_FALL
		or player.powers[pw_super] == 1
		or player.iseggrobo
		or (player.dirk_frozen)
		or (player.gotflag or player.gotcrystal)
		or player.powers[pw_nocontrol]
			if player.mo.state == S_PLAY_DASH
				player.mo.state = S_PLAY_RUN
			end
			resetwhirl(player)
		return end
		
		//Wait SFX
		if player.mo.sprite2 == SPR2_WAIT
			if player.mo.frame&FF_FRAMEMASK == 1
				if not player.whirlidlebonk
					S_StartSound(player.mo, sfx_wodbnk)
					player.whirlidlebonk = true
				end
			else
				player.whirlidlebonk = false
			end
		end
		
		//Propeller fly
		if player.whirltornadojump
			if P_IsObjectOnGround(player.mo) or player.mo.eflags&MFE_SPRUNG
			or player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectInGoop(player.mo)
			or (player.whirltornadojump > 1 and player.mo.momz*P_MobjFlip(player.mo) > 0)
			or player.mo.state != S_PLAY_SPINDASH
				if player.whirltornadojump > 1
					if player.mo.eflags&MFE_SPRUNG
						player.mo.momx = $*5/4
						player.mo.momy = $*5/4
						player.mo.momz = $*5/4
						S_StartSound(player.mo, sfx_sprong)
						if (player.mo.eflags & MFE_UNDERWATER)
							local ex = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_UWEXPLODE)
							if ex and ex.valid ex.scale = $/2 end
						else
							P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.scale*P_MobjFlip(player.mo), MT_SPINDUST)
						end
						groundnuke(player.mo, player.mo, 250*FRACUNIT)
						whirlcircle(player.mo, MT_DUST, 32 << FRACBITS, false, 0)
						whirlcircle(player.mo, MT_DUST, 16 << FRACBITS, false, 0)
						P_SpawnMobjFromMobj(player.mo,0,0,0,MT_EXPLODE)
						if player == displayplayer
							P_StartQuake(20*FRACUNIT, 7)
						end
						S_StartSoundAtVolume(player.mo, sfx_s3k5f, 192)
					elseif P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
						player.mo.state = S_PLAY_GLIDE_LANDING
						player.mo.tics = 18
						player.powers[pw_nocontrol] = max($,18)
						player.mo.reactiontime = max($,18)
						groundnuke(player.mo, player.mo, 300*FRACUNIT)
						whirlcircle(player.mo, MT_DUST, 32 << FRACBITS, false, 0)
						whirlcircle(player.mo, MT_DUST, 16 << FRACBITS, false, 0)
						P_SpawnMobjFromMobj(player.mo,0,0,0,MT_EXPLODE)
						if player == displayplayer
							P_StartQuake(20*FRACUNIT, 7)
						end
						S_StartSoundAtVolume(player.mo, sfx_s3k5f, 192)
					elseif player.mo.momz*P_MobjFlip(player.mo) > 0
						player.mo.momz = $/2
					end
				end
				if player.mo.state == S_PLAY_SPINDASH
					player.mo.state = S_PLAY_FALL
				end
				player.whirltornadojump = 0
				player.normalspeed = skins[player.mo.skin].normalspeed
				S_StopSoundByID(player.mo, sfx_whrdrl)
				
			elseif player.whirltornadojump > 1
				player.pflags = $|PF_JUMPSTASIS
				player.mo.tics = 1
				local sectorthing = P_PlayerTouchingSectorSpecial(player, 0, 0)
				if sectorthing.valid and player.mo.state == S_PLAY_SPINDASH then
					for fof in sectorthing.ffloors()
						if fof.valid and (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
						and (abs(fof.topheight - player.mo.z) <= 40*player.mo.scale) then
							EV_CrumbleChain(player.sectorthing, fof)
						end
					end
				end
			else
				local gravity = P_GetMobjGravity(player.mo)*8
				if gravity > 0
					player.mo.momz = min($,gravity)
				else
					player.mo.momz = max($,gravity)
				end
				if player.mo.momz*P_MobjFlip(player.mo) > 17*player.mo.scale
					P_InstaThrust(player.mo,0,0)
				end
			end
			
			local dust = P_SpawnMobjFromMobj(player.mo,
			P_ReturnThrustX(nil, ANG60*(player.mo.frame&FF_FRAMEMASK), FixedDiv(player.mo.radius,player.mo.scale)*5/4),
			P_ReturnThrustY(nil, ANG60*(player.mo.frame&FF_FRAMEMASK), FixedDiv(player.mo.radius,player.mo.scale)*5/4),
			FixedDiv(player.mo.height/3+(player.mo.momz*P_MobjFlip(player.mo)),player.mo.scale), MT_SPINDUST)
			if not verydangerouschasecamvariable and player == displayplayer
				dust.flags2 = $|MF2_DONTDRAW
			end
			local dust = P_SpawnMobjFromMobj(player.mo,
			P_ReturnThrustX(nil, (ANG60*(player.mo.frame&FF_FRAMEMASK))+ANGLE_180, FixedDiv(player.mo.radius,player.mo.scale)*5/4),
			P_ReturnThrustY(nil, (ANG60*(player.mo.frame&FF_FRAMEMASK))+ANGLE_180, FixedDiv(player.mo.radius,player.mo.scale)*5/4),
			FixedDiv(player.mo.height/3+(player.mo.momz*P_MobjFlip(player.mo)),player.mo.scale), MT_SPINDUST)
			if not verydangerouschasecamvariable and player == displayplayer
				dust.flags2 = $|MF2_DONTDRAW
			end
			
			for i = 0, 10
				local dust = P_SpawnMobjFromMobj(player.mo,75*(P_RandomFixed()-(FRACUNIT/2)),
				75*(P_RandomFixed()-(FRACUNIT/2)),
				(75*(P_RandomFixed()-(FRACUNIT/2)))+(player.mo.height/2),MT_DUST)
				if dust and dust.valid
					dust.momx = 5*(P_RandomFixed()-(FRACUNIT/2))+player.mo.momx
					dust.momy = 5*(P_RandomFixed()-(FRACUNIT/2))+player.mo.momy
					dust.momz = player.mo.momz/2
					dust.scale = $/2
					if not verydangerouschasecamvariable and player == displayplayer
						dust.flags2 = $|MF2_DONTDRAW
					end
				end
			end
		end
		
		if player.whirlbonkangle != nil
			if P_IsObjectOnGround(player.mo) or player.mo.state != S_PLAY_FLY
				player.whirlbonkangle = nil
			else
				player.drawangle = player.whirlbonkangle
			end
		end
		
		//Ram Charge
		if player.whirlram
			//Spring Boost
			//Only Horizontal springs boost. Other ones just cancel the ram.
			if player.mo.eflags&MFE_SPRUNG
				local sidewaysspring
				local endresult = 65*FRACUNIT
				searchBlockmap("objects", function(refmobj, foundmobj)
					if (foundmobj.type == MT_YELLOWHORIZ or foundmobj.type == MT_REDHORIZ
					or foundmobj.type == MT_BLUEHORIZ)
					and foundmobj.z - foundmobj.scale <= refmobj.z + refmobj.height
					and foundmobj.z + foundmobj.height + foundmobj.scale >= refmobj.z
						if foundmobj.type == MT_REDHORIZ
							endresult = max($,94*FRACUNIT)
						elseif foundmobj.type == MT_BLUEHORIZ
							endresult = max($,65*FRACUNIT)
						else
							endresult = max($,70*FRACUNIT)
						end
						sidewaysspring = true
					end
				end, player.mo)
				if sidewaysspring
					player.whirlramboost = endresult
					player.normalspeed = player.whirlramboost
					player.whirlramspeed = FixedMul(player.whirlramboost, player.mo.scale)
					player.whirlramangle = player.drawangle
					player.camerascale = FRACUNIT*2
					S_StartSound(player.mo, sfx_sprong)
					if player.mo.eflags&MFE_UNDERWATER
						P_InstaThrust(player.mo, player.drawangle, FixedMul(player.whirlramboost/2, player.mo.scale))
					else
						P_InstaThrust(player.mo, player.drawangle, FixedMul(player.whirlramboost, player.mo.scale))
					end
				else
					player.whirlram = false
					player.pflags = $&~PF_FORCESTRAFE
					player.normalspeed = skins[player.mo.skin].normalspeed
					player.charflags = $&~SF_RUNONWATER
					player.camerascale = FRACUNIT
					S_StopSoundByID(player.mo, sfx_s3kcfl)
				end
				
			//Cancel the Ram
			elseif (not (player.cmd.buttons&BT_SPIN) and P_IsObjectOnGround(player.mo))
			or P_IsObjectInGoop(player.mo) or player.pflags&PF_SPINNING
				player.whirlram = false
				player.pflags = $&~PF_FORCESTRAFE
				player.normalspeed = skins[player.mo.skin].normalspeed
				player.charflags = $&~SF_RUNONWATER
				player.camerascale = FRACUNIT
				S_StopSoundByID(player.mo, sfx_s3kcfl)
				if P_IsObjectOnGround(player.mo) and not (player.pflags&PF_SPINNING)
					player.mo.state = S_PLAY_RUN
				end
			
			//The Ram itself
			else
				player.normalspeed = player.whirlramboost
				player.camerascale = max($-FRACUNIT/35,FRACUNIT*2/3)
				if not (player.mo.flags2 & MF2_TWOD or twodlevel)
					player.whirlramangle = $-(player.cmd.sidemove*FRACUNIT*8)
				end
				player.mo.angle = player.whirlramangle
				player.drawangle = player.mo.angle
				player.pflags = $&~PF_APPLYAUTOBRAKE|PF_FORCESTRAFE
				player.charflags = $|SF_RUNONWATER
				player.skidtime = 0
				
				//Extra Speed from Springs
				if player.whirlramboost > 50*FRACUNIT
					player.whirlchargetime = RAMCHARGING_GHOST_TICS 
				elseif player.whirlramboost < 50*FRACUNIT
					player.whirlramboost = 50*FRACUNIT
				end
				
				//Ram Trails
				if player.whirlchargetime
					player.whirlchargetime = $ - 1
					if leveltime%3 and player.whirlramboost >= 65*FRACUNIT
						P_SpawnWhirlTrail(player.mo)
					end
				end
				
				//Actual boost based on underwater and speedshoes
				local actualboost = player.whirlramboost
				if player.mo.eflags&MFE_UNDERWATER
				and not (player.powers[pw_sneakers] or player.powers[pw_super])
					actualboost = player.whirlramboost/2
				elseif player.powers[pw_sneakers] or player.powers[pw_super]
					actualboost = player.whirlramboost*3/2
				end
				
				//Grounded Ram
				if P_IsObjectOnGround(player.mo)
					if not (leveltime%3)
						S_StartSoundAtVolume(player.mo, sfx_s251, 96)
					end
					
					//The Thrust
					local accel = 5
					if player.whirlramboost > 60*FRACUNIT
					or player.powers[pw_sneakers] or player.powers[pw_super]
						accel = $*4
					end
					local thrust = min(player.speed+(accel*player.mo.scale),
					FixedMul(actualboost, player.mo.scale))
					if player.onconveyor
						player.mo.momx = P_ReturnThrustX(nil, player.drawangle, thrust)
						+player.cmomx
						player.mo.momy = P_ReturnThrustY(nil, player.drawangle, thrust)
						+player.cmomy
					else
						P_InstaThrust(player.mo, player.drawangle, thrust)
					end
					player.whirlramspeed = player.speed
					if player.mo.state != S_PLAY_DASH
						player.mo.state = S_PLAY_DASH
					end
					//Running dust code from Skip, which was the Spindash dust
					//from SRB2 Sonic for Kart, which was the Spindash dust from SRB2
					local i = 0 while i <= (leveltime%7)/2 // 1, 2, 3 or 4 particles
						local particle
						if player.mo.eflags & (MFE_TOUCHWATER|MFE_UNDERWATER)
							particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SMALLBUBBLE)
						else
							particle = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_SPINDUST)
							if (player.powers[pw_shield] & SH_NOSTACK) == SH_ELEMENTAL
								particle.state = S_SPINDUST_FIRE1
							end
						end
						P_TryMove(particle, particle.x+P_ReturnThrustX(nil,player.drawangle+ANGLE_180,player.mo.radius),
						particle.y+P_ReturnThrustY(nil,player.drawangle+ANGLE_180,player.mo.radius), true)
				
						particle.target = player.mo
						particle.destscale = (2*player.mo.scale)/3
						P_SetScale(particle, particle.destscale)
						if (player.mo.eflags & MFE_VERTICALFLIP) // readjust z position if needed
							particle.z = player.mo.z + player.mo.height - particle.height
						end
						local prandom = {}
						prandom[0] = P_RandomFixed()<<2 // P_RandomByte()<<10
						prandom[1] = P_RandomRange(-30, 30) // P_RandomRange(-ANG30/FRACUNIT, ANG30/FRACUNIT)*FRACUNIT
						prandom[2] = P_RandomFixed()<<3 // P_RandomByte()<<11
						P_SetObjectMomZ(particle, player.maxdash/50 + prandom[0], false)
						P_InstaThrust(particle,
							player.drawangle + (prandom[1]*ANG1),
							-FixedMul(player.maxdash/12 + FRACUNIT + prandom[2], player.mo.scale))
						particle.momx = $+player.mo.momx
						particle.momy = $+player.mo.momy
						P_TryMove(particle, particle.x+particle.momx, particle.y+particle.momy, true)
						
						i = $+1
					end
				//Aerial Ram
				else
					local dumbinput = player.cmd.forwardmove
					if player.mo.flags2 & MF2_TWOD or twodlevel
						if player.drawangle > ANGLE_180
							dumbinput = player.cmd.sidemove
						else
							dumbinput = player.cmd.sidemove*-1
						end
					end
					player.whirlramspeed = min(max($+min(dumbinput*player.mo.scale/48,0),0), FixedMul(actualboost, player.mo.scale))
					P_InstaThrust(player.mo, player.drawangle, player.whirlramspeed)
					player.pflags = $ | PF_THOKKED
					if player.mo.state != S_PLAY_FLY
						player.mo.state = S_PLAY_FLY
					end
				end
				
				local i = 0	while i < 8
				and (player.speed >= 32*player.mo.scale or P_IsObjectOnGround(player.mo))
					local fa = (i*(ANGLE_180/4))+(ANGLE_11hh*(leveltime%4))
					local ns = FixedMul(12 << FRACBITS, player.mo.scale)
					local mo = P_SpawnMobjFromMobj(player.mo,
					P_ReturnThrustX(nil,player.drawangle,32*FRACUNIT),
					P_ReturnThrustY(nil,player.drawangle,32*FRACUNIT),
					(player.mo.momz*P_MobjFlip(player.mo))+(FixedDiv(player.mo.height, player.mo.scale)/2), MT_SMOKE)
					if mo and mo.valid
						if not verydangerouschasecamvariable and player == displayplayer
							mo.flags2 = $|MF2_DONTDRAW
						end
						mo.angle = player.drawangle
						mo.state = S_WHIRLSMOKE1
						mo.momz = FixedMul(sin(fa),ns)/2
						P_InstaThrust(mo, player.drawangle+ANGLE_90,
						FixedMul(cos(fa),ns)/2)
						P_TeleportMove(mo, mo.x+(mo.momx*2), mo.y+(mo.momy*2), mo.z+(mo.momz*2))
						mo.momx = $+(player.mo.momx*2/3)
						mo.momy = $+(player.mo.momy*2/3)
						mo.color = SKINCOLOR_SUPERSILVER1
						mo.colorized = true
					end
					i = $+1
				end
				
				//Code from Kart
				local fast = P_SpawnMobj(player.mo.x + (P_RandomRange(-36,36) * player.mo.scale),
				player.mo.y + (P_RandomRange(-36,36) * player.mo.scale),
				player.mo.z + (player.mo.height/2) + (P_RandomRange(-20,20) * player.mo.scale),
				MT_SMOKE)
				if fast and fast.valid
					fast.state = S_WHIRLTRAIL
					fast.angle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)//-(player.cmd.sidemove*FRACUNIT*8)
					fast.momx = 3*player.mo.momx/4
					fast.momy = 3*player.mo.momy/4
					fast.momz = 3*player.mo.momz/4
					fast.scale = player.mo.scale
				end
				
				if (player.speed >= 32*player.mo.scale or P_IsObjectOnGround(player.mo))
					if not S_SoundPlaying(player.mo, sfx_s3kcfl)
						S_StartSound(player.mo, sfx_s3kcfl)
					end
				elseif S_SoundPlaying(player.mo, sfx_s3kcfl)
					S_StopSoundByID(player.mo, sfx_s3kcfl)
				end
			end
		//Start the Ram
		elseif player.cmd.buttons&BT_SPIN and P_IsObjectOnGround(player.mo)
		and player.bot != 1
			S_StartSoundAtVolume(player.mo, sfx_s3k4b, 128)
			local i = 0	while i < 16
				local fa = (i*(ANGLE_180/8))
				local ns = FixedMul(12 << FRACBITS, player.mo.scale)
				local mo = P_SpawnMobjFromMobj(player.mo,
				P_ReturnThrustX(nil,player.mo.angle,32*FRACUNIT),
				P_ReturnThrustY(nil,player.mo.angle,32*FRACUNIT),
				(player.mo.momz*P_MobjFlip(player.mo))+(FixedDiv(player.mo.height, player.mo.scale)/2), MT_SMOKE)
				if mo and mo.valid
					if not verydangerouschasecamvariable and player == displayplayer
						mo.flags2 = $|MF2_DONTDRAW
					end
					mo.flags = $|MF_NOCLIP|MF_NOCLIPHEIGHT
					mo.state = S_WHIRLSMOKE1
					mo.momz = FixedMul(sin(fa),ns)
					P_InstaThrust(mo, player.mo.angle+ANGLE_90,
					FixedMul(cos(fa),ns))
					P_TeleportMove(mo, mo.x+(mo.momx*5), mo.y+(mo.momy*5), mo.z+(mo.momz*5))
					mo.momx = ($*-1)+(player.mo.momx*2/3)
					mo.momy = ($*-1)+(player.mo.momy*2/3)
					mo.momz = $*-1
					mo.color = SKINCOLOR_SUPERSILVER1
					mo.colorized = true
				end
				i = $+1
			end
			player.pflags = $&~PF_SPINNING
			player.whirlram = true
			player.whirlramangle = player.mo.angle
			if CBW_Battle and CBW_Battle.BattleGametype() then //Battle mod nerfs
				player.whirlramboost = 46*FRACUNIT	
			else
				player.whirlramboost = 60*FRACUNIT
			end
		end
		if not player.whirlram
			player.whirlchargetime = 0
		end
	
	//Spinning while being carried by Whirl
	elseif player.mo and player.mo.valid and player.powers[pw_carry] == CR_PLAYER
	and player.mo.tracer and player.mo.tracer.valid and player.mo.tracer.player
	and player.mo.tracer.skin == "whirl" and player.mo.tracer.player.whirltornadojump
		player.drawangle = (ANG60*(player.mo.tracer.frame&FF_FRAMEMASK))-ANGLE_135
	end
end)

//Bonking into walls while ramming
addHook("MobjMoveBlocked", function(mobj)
	if mobj and mobj.valid and mobj.player and mobj.skin == "whirl"
	and mobj.player.whirlram
	and mobj.player.speed > FixedMul(mobj.player.normalspeed/2, mobj.scale)
		mobj.player.whirlbonkangle = mobj.player.drawangle
		P_InstaThrust(mobj, mobj.player.whirlbonkangle+ANGLE_180, mobj.player.whirlramspeed/2)
		P_SetObjectMomZ(mobj, mobj.player.jumpfactor*(39/6), false)
		local particle = P_SpawnMobj(mobj.x, mobj.y, mobj.z+mobj.height, MT_PARTICLE)
		if particle and particle.valid
			particle.state = S_RAMSPARKS1
		end
		mobj.z = $+P_MobjFlip(mobj)
		mobj.state = S_PLAY_FLY
		mobj.player.pflags = $&~PF_FORCESTRAFE
		mobj.player.normalspeed = skins[mobj.skin].normalspeed
		mobj.player.charflags = $&~SF_RUNONWATER
		mobj.player.camerascale = FRACUNIT
		S_StopSoundByID(mobj, sfx_s3kcfl)
		mobj.player.whirlram = false
		if mobj.player == displayplayer
			P_StartQuake(10*FRACUNIT, 7)
		end
		if P_RandomChance(FRACUNIT/50) then
			if P_RandomChance(FRACUNIT/2) then
				S_StartSound(mobj, sfx_whrbn2)
			else
				S_StartSound(mobj, sfx_whrbnk)
			end
		else
			S_StartSound(mobj, sfx_s3k5f)
			S_StartSoundAtVolume(mobj, sfx_s3k59, 128)
		end
	end
end, MT_PLAYER)

//Damaging enemies with the ram move
addHook("PlayerCanDamage", function(player, mobj)
	if player.mo and player.mo.skin == "whirl"
	and (player.mo.state == S_PLAY_SPINDASH
	or (player.whirlram and mobj and mobj.valid and mobj.health
	and R_PointToAngle2(player.mo.x, player.mo.y, mobj.x, mobj.y)-player.drawangle <= ANGLE_90))
		return true
	end
end)

//Bouncing back from damaging using the ram and drill move
addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	local whirl
	local speeddiv = 3
	local returnvalue = nil
	if inflictor and inflictor.valid and inflictor.player and inflictor.skin == "whirl"
	and inflictor.player.whirlram
		whirl = inflictor
		whirl.player.powers[pw_flashing] = max($,5)
		if target and target.valid
			if target.health <= 1
				P_InstaThrust(whirl,0,0)
				local particle = P_SpawnMobj(whirl.x, whirl.y, whirl.z+whirl.height, MT_PARTICLE)
				if particle and particle.valid
					particle.state = S_RAMSPARKS1
				end
				S_StartSound(whirl, sfx_s3k5f)
				S_StartSoundAtVolume(whirl, sfx_cdfm14, 128)
				return
			end
			whirl.player.whirlbonkangle = R_PointToAngle2(inflictor.x, inflictor.y, target.x, target.y)
			if target.info.spawnhealth > 1
				speeddiv = 1
			end
		else
			whirl.player.whirlbonkangle = whirl.player.drawangle
		end
	elseif (damagetype == 0 or damagetype == DMG_SPIKE)
	and target and target.valid and target.player and target.skin == "whirl"
	and target.player.whirlram and inflictor and inflictor.valid
	and inflictor.type != MT_TURRETLASER and inflictor.type != MT_DEMONFIRE
	and inflictor.type != MT_ROCKET
	and R_PointToAngle2(target.x, target.y, inflictor.x, inflictor.y)-target.player.drawangle <= ANGLE_90
		whirl = target
		whirl.player.powers[pw_flashing] = max($,5)
		if inflictor.type == MT_SPIKE
			return
		elseif inflictor.flags&MF_SOLID
			return true
		end
		whirl.player.whirlbonkangle = R_PointToAngle2(target.x, target.y, inflictor.x, inflictor.y)
		returnvalue = true
	else return end
	
	P_InstaThrust(whirl, whirl.player.whirlbonkangle+ANGLE_180, whirl.player.whirlramspeed/speeddiv)
	P_SetObjectMomZ(whirl, whirl.player.jumpfactor*(39/8), false)
	local particle = P_SpawnMobj(whirl.x, whirl.y, whirl.z+whirl.height, MT_PARTICLE)
	if particle and particle.valid
		particle.state = S_RAMSPARKS1
	end
	whirl.state = S_PLAY_FLY
	whirl.player.pflags = $&~PF_FORCESTRAFE
	whirl.player.normalspeed = skins[whirl.skin].normalspeed
	whirl.player.charflags = $&~SF_RUNONWATER
	whirl.player.camerascale = FRACUNIT
	S_StopSoundByID(whirl, sfx_s3kcfl)
	whirl.player.whirlram = false
	if whirl.player == displayplayer
		P_StartQuake(10*FRACUNIT, 7)
	end
	S_StartSound(whirl, sfx_s3k5f)
	S_StartSoundAtVolume(whirl, sfx_cdfm14, 128)
	return returnvalue
end)

//Destroy spikes by ramming into them
local waterspike = function(thing, tmthing)
	if not (thing and thing.valid and tmthing and tmthing.valid) return end
	if tmthing.player and tmthing.skin == "whirl"
	and (tmthing.player.whirlram or tmthing.player.whirltornadojump > 1)
		local extraz = tmthing.momz
		if tmthing.player.whirlram
			extraz = 0
		end
		if (thing.z - thing.scale <= tmthing.z + tmthing.height + extraz
		and thing.z + thing.height + thing.scale >= tmthing.z + extraz)
			if tmthing.player.whirlram
				tmthing.momx = $*4/5 tmthing.momy = $*4/5
				local particle = P_SpawnMobj(tmthing.x, tmthing.y, tmthing.z+tmthing.height, MT_PARTICLE)
				if particle and particle.valid
					particle.state = S_RAMSPARKS1
					particle.scale = $/2
				end
				S_StartSound(tmthing, sfx_s3k5f)
			end
			P_KillMobj(thing, tmthing)
			return true
		end
	end
end
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_SPIKE)
addHook("MobjCollide", function(thing, tmthing) waterspike(thing, tmthing) end, MT_WALLSPIKE)